Subject: Re: bug#39385: Erroneous interaction of eval-when-compile and condition-case

From: Alan Mackenzie <[email-masked]>
Date: Sun, 2 Feb 2020 13:20:24 +0000

Hello, Noam.

On Sat, Feb 01, 2020 at 20:04:11 -0500, Noam Postavsky wrote:
> Alan Mackenzie <[email-masked]> writes:

> > ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
> > (defmacro c-safe (&rest body)
> >   ;; safely execute BODY, return nil if an error occurred
> >   `(condition-case nil
> >        (progn ,@body)
> >      (error nil)))

> > (defmacro foo ()
> >   (error "This message should not be seen"))

> > (eval-when-compile
> >   (c-safe (foo)))
> > ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

> > Now do M-x byte-compile-file <CR> bad-eval-when-compile.el <CR>.  This
> > erroneously throws the error:

> >     This message should not be seen

> The same happens without eval-when-compile.

> > .  This should have been caught by the condition-case generated by
> > (c-safe ...).

> I don't think so, because the condition-case is in the code generated by
> c-safe (because the condition-case is quoted), whereas the error is
> signaled while generating the code (because the error call is not
> quoted).

Ah, I think I've got it.  The macro is being expanded before the
condition-case is active, and this is when it throws the error.

Thanks for the help.

I'll close this as notabug.

-- 
Alan Mackenzie (Nuremberg, Germany).